<template>
    <v-flex class="d-flex">
        <v-autocomplete
           v-model="select"
           :loading="loading"
           :items="items"
           :search-input.sync="search"
           cache-items
           class="mx-3"
           flat
           hide-no-data
           hide-details
           label="Search..."
           solo-inverted
        ></v-autocomplete>
        <v-btn color="info" @click="getSearch">
            Search
        </v-btn>
    </v-flex>
</template>

<script>
    export default {
        data () {
            return {
                loading: false,
                search: null,
                select: null,
                items: [],
                taskNamesArray: '',
            }
        },
        watch:{
            search (val) {
                val && val !== this.select && this.querySelections(val);
            }
        },
        methods: {
            querySelections (v) {
                this.taskNamesArray = JSON.parse(localStorage.getItem('tasks')).map(item => item.name);
                this.loading = true;
                // Simulated ajax query
                setTimeout( () => {
                    this.items = this.taskNamesArray.filter(e => {
                        return (e || '').toLowerCase().indexOf((v || '').toLowerCase()) > -1
                    });
                    this.loading = false
                }, 500)
            },
            getSearch () {
                const taskData = JSON.parse(localStorage.getItem('tasks')).filter(item => item.name === this.select);
                this.$emit('transmittedData', taskData);
            }
        },
    }
</script>